//+------------------------------------------------------------------+
//|                                        TimeFrame 2007 w Time.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//|                  Created by : Xard777, xard777@connectfree.co.uk |
//|              Modified (added time) : programmer wishes anonymity |
//|                    Version Updates : 25 Jan, 2007; v0.02         |
//|                                      29 Jan, 2007; v0.03         |
//|                                      05 Feb, 2007; v0.04         |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "Xard777" 
#property link      "http://www.metaquotes.net"
#property link      "Xard777@connectfree.co.uk"

#property indicator_chart_window

extern int P = 64;
extern int StepBack = 0;
extern bool Frame=true;
extern bool Fractals=true;  //true = original settings, false = new settings
extern bool BabyLines=False;
extern bool Show.Yesterdays.Close=True;
extern bool TimeLines=True;
extern bool MMTables=True;
extern int Table.Font.Size = 10;
extern int Table.X.Offset = 0;//-250 for 1024mode, default 0 = 1280mode screen res
extern int Table.Y.Offset = 0;
extern int TradingFrame=256;  //256 Days,64 Days,32 Days,16 Days,8 Days,4 Days
extern datetime HM.Date =D'2006.10.09 4:00';
extern bool intra.day.lines=true;
extern int Day.Offset=0;
extern int Font.Size = 10;
extern color Text.Color=Black;
extern bool Text.Color.Line=True;
//-- Line colors
extern color MMColor = C'0,6,60';
extern color MM2Color = C'100,5,60';
extern color PlusMinus2.8= Red;
extern color PlusMinus1.8= OrangeRed;
extern color ZeroEight.8 = DeepSkyBlue;
extern color OneSeven.8  = Yellow;
extern color TwoSix.8   = HotPink;
extern color ThreeFive.8 = Lime;
extern color Four.8      = DeepSkyBlue;
//-- Day Box Paramenters
extern bool Day.Boxes=true;
extern int    NumberOfDays = 50;        
extern string Begin_1      = "08:00";//"08:00"
extern string End_1        = "11:00";//"11:00"
extern color  Color_1      = DarkBlue;
extern string Begin_2      = "14:00";//"14:00"
extern string End_2        = "17:00";//"17:00"
extern color  Color_2      = DarkSlateGray;
extern bool   HighRange    = true;


#define FF1 "FF1"
#define FF2 "FF2"
#define FF3 "FF3"
#define YC "YC"

double  dmml = 0,
        dvtl = 0,
        sum  = 0,
        v1 = 0,
        v2 = 0,
        mn = 0,
        mx = 0,
        x1 = 0,
        x2 = 0,
        x3 = 0,
        x4 = 0,
        x5 = 0,
        x6 = 0,
        y1 = 0,
        y2 = 0,
        y3 = 0,
        y4 = 0,
        y5 = 0,
        y6 = 0,
        octave = 0,
        fractal = 0,
        range   = 0,
        finalH  = 0,
        finalL  = 0,
        mml[13];
        
string  ln_txt[13],        
        buff_str = "";
        
int     
        bn_v1   = 0,
        bn_v2   = 0,
        OctLinesCnt = 13,
        mml_thk = 8,
        mml_clr[13],
        mml_shft = 3,
        nTime = 0,
        CurPeriod = 0,
        nDigits = 0,
        i = 0,
        mP = 0,
        d = 0;
        
// Time Point Variables
string TimePointObjects[18];
datetime TimePointTime[18];
color TimePointColor[18];
datetime TimeGrid[1],TimeGridByDay[1];
static datetime BlockStart,BlockEnd,BlockEndText,dt;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
IndicatorShortName("MM");
//---- indicators
   ln_txt[0]  = "[-2/8]                                 ";
   ln_txt[1]  = "[-1/8]                                 ";
   ln_txt[2]  = "[0/8]                                 ";
   ln_txt[3]  = "[1/8]                                 ";
   ln_txt[4]  = "[2/8]                                 ";
   ln_txt[5]  = "[3/8]                                 ";
   ln_txt[6]  = "[4/8]                                 ";
   ln_txt[7]  = "[5/8]                                 ";
   ln_txt[8]  = "[6/8]                                 ";
   ln_txt[9]  = "[7/8]                                 ";
   ln_txt[10] = "[8/8]                                 ";
   ln_txt[11] = "[+1/8]                                 ";
   ln_txt[12] = "[+2/8]                                 ";

   mml_shft = 5;//original was 3
   mml_thk  = 3;
   
   mml_clr[0]  = PlusMinus2.8;
   mml_clr[1]  = PlusMinus1.8;
   mml_clr[2]  = ZeroEight.8;
   mml_clr[3]  = OneSeven.8;
   mml_clr[4]  = TwoSix.8;
   mml_clr[5]  = ThreeFive.8;
   mml_clr[6]  = Four.8;
   mml_clr[7]  = ThreeFive.8;
   mml_clr[8]  = TwoSix.8;
   mml_clr[9]  = OneSeven.8;
   mml_clr[10] = ZeroEight.8;
   mml_clr[11] = PlusMinus1.8;
   mml_clr[12] = PlusMinus2.8;
   
//----

   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
//---- TODO: add your code here
Comment("\n","  ");   
for(i=0;i<OctLinesCnt;i++) {
    buff_str = "mml"+i;
    ObjectDelete(buff_str);
    buff_str = "mml_txt"+i;
    ObjectDelete(buff_str);
    }
//---- Day Box Objects
   DeleteObjects();
  ObjectDelete("X633");ObjectDelete("X629");ObjectDelete("X630"); 
//----
   ObjectDelete(FF1);
   ObjectDelete(FF2);
   ObjectDelete(FF3);
   
  ObjectsDeleteAll(0,OBJ_TRENDBYANGLE);
  //ObjectsDeleteAll(0,OBJ_RECTANGLE);
  ObjectsDeleteAll(0,OBJ_TEXT); 
  ObjectsDeleteAll(0,OBJ_LABEL);
  ObjectsDeleteAll(0,OBJ_VLINE);

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() 
{

// Init timelines code
if (TimeLines) {
   LoadTimeGrid(TimeGrid,TimeGridByDay);
   TimePointProcess(TimePointObjects,TimePointTime,TimePointColor);
}
// Day Box Init
if (Day.Boxes) {
    DayBoxInit();
} 

//Outer Wine coloured Boxes   
CreateMM3();
  
}

void CreateMM3() {
   //{
   //DeleteObjects();
   // ObjectsDeleteAll(0,OBJ_RECTANGLE);
   ObjectDelete(FF1);
   ObjectDelete(FF2);
   ObjectDelete(FF3);
   
   ObjectsRedraw();
   
   // Start Data window code
   double Value = finalH; //8/8th 
   double Value1 = finalL; //0/8th



   if( (nTime != Time[0]) || (CurPeriod != Period()) ) {
   
       v1=(Close[Lowest(NULL,0,MODE_CLOSE,P+StepBack,0)]);
      v2=(Close[Highest(NULL,0,MODE_CLOSE,P+StepBack,0)]);
   }

//determine fractal.....
if (Fractals) {
   if( v2<=250000 && v2>25000 )
   fractal=100000;
   else
     if( v2<=25000 && v2>2500 )
     fractal=10000;
     else
       if( v2<=2500 && v2>250 )
       fractal=1000;
       else
         if( v2<=250 && v2>25 )
         fractal=100;
         else
           if( v2<=25 && v2>12.5 )
           fractal=12.5;
           else
             if( v2<=12.5 && v2>6.25)
             fractal=12.5;
             else
               if( v2<=6.25 && v2>3.125 )
               fractal=6.25;
               else
                 if( v2<=3.125 && v2>1.5625 )
                 fractal=3.125;
                 else
                   if( v2<=1.5625 && v2>0.390625 )
                   fractal=1.5625;
                   else
                     if( v2<=0.390625 && v2>0)
                     fractal=0.1953125;
                     
ObjectCreate("X642", OBJ_LABEL, 0, 0, 0);//HiLow LABEL
        ObjectSetText("X642","ORIGINAL FRACTAL TABLE", 7, "Arial Bold", White);
        ObjectSet("X642", OBJPROP_CORNER, 2);
        ObjectSet("X642", OBJPROP_XDISTANCE, 1085 + Table.X.Offset);
        ObjectSet("X642", OBJPROP_YDISTANCE, 325 + Table.Y.Offset);
                     
                     }

if (Fractals == false) {                     
  if( v2<=200000 && v2>20000 )
   fractal=80000;
   else
     if( v2<=20000 && v2>2000 )
     fractal=8000;
     else
       if( v2<=2000 && v2>200 )
       fractal=800;
       else
         if( v2<=200 && v2>20 )
         fractal=80;
         else
           if( v2<=20 && v2>2.0 )
           fractal=8;
           else
             if( v2<=2.0 && v2> 0.20 )
             fractal=.8;  
             else
               if( v2<=0.20 && v2> 0.020 )
               fractal=0.08;
               
ObjectCreate("X641", OBJ_LABEL, 0, 0, 0);//HiLow LABEL
        ObjectSetText("X641","EXPERIMENTAL FRACTAL TABLE", 7, "Arial Bold", White);
        ObjectSet("X641", OBJPROP_CORNER, 2);
        ObjectSet("X641", OBJPROP_XDISTANCE, 1072 + Table.X.Offset);
        ObjectSet("X641", OBJPROP_YDISTANCE, 325 + Table.Y.Offset);               
               
               }
                     
//
if (!TimeLines) {
   BlockStart=iTime(NULL,Period(),P);
   BlockEnd = FutureBarTime(-48);
   BlockEndText = FutureBarTime(-44);
}    
//---- input parameters ----
double m0,m8,m7,m6,m5,m4,m3,m2,m1;
double mm0,mm8,mm7,mm6,mm5,mm4,mm3,mm2,mm1,mm11,mm12,mm13,mm14;
double mm15,mm16,mm17,mm18;
double mm30,mm31,mm32,mm33,mm34,mm35,mm36,mm37,mm38,mm3P1,mm3P2,mm3M1,mm3M2;
double mm313, mm314, mm315, mm316;
double H2DAILY = iMA(Symbol(),PERIOD_D1,1,0,MODE_HIGH,PRICE_HIGH,0);
double LDAILY = iMA(Symbol(),PERIOD_D1,1,0,MODE_LOW,PRICE_LOW,0);
double xard = iMA(Symbol(),0,1,0,MODE_EMA,PRICE_CLOSE,0);
double column1=8,octave1=64;//1st column
double column2=64,octave2=512;//2nd column
double column3=512,octave3=4096;//3rd column

ObjectCreate("X633", OBJ_LABEL, 0, 0, 0);
        ObjectSetText("X633",DoubleToStr(xard,Digits), 30, "Arial Bold", White);
        ObjectSet("X633", OBJPROP_CORNER, 2);
        ObjectSet("X633", OBJPROP_XDISTANCE, 1065 + Table.X.Offset);
        ObjectSet("X633", OBJPROP_YDISTANCE, 60 + Table.Y.Offset);  

ObjectCreate("X629", OBJ_LABEL, 0, 0, 0);//HiLow LABEL
        ObjectSetText("X629","HIGH", 9, "Arial Bold", Silver);
        ObjectSet("X629", OBJPROP_CORNER, 2);
        ObjectSet("X629", OBJPROP_XDISTANCE, 1085 + Table.X.Offset);
        ObjectSet("X629", OBJPROP_YDISTANCE, 47 + Table.Y.Offset);

ObjectCreate("X630", OBJ_LABEL, 0, 0, 0);//HiLow LABEL
        ObjectSetText("X630","LOW", 9, "Arial Bold", Silver);
        ObjectSet("X630", OBJPROP_CORNER, 2);
        ObjectSet("X630", OBJPROP_XDISTANCE, 1145 + Table.X.Offset);
        ObjectSet("X630", OBJPROP_YDISTANCE, 47 + Table.Y.Offset);
        
ObjectCreate("X632", OBJ_LABEL, 0, 0, 0);
        ObjectSetText("X632",DoubleToStr(H2DAILY,Digits), 13, "Arial Bold", White);
        ObjectSet("X632", OBJPROP_CORNER, 2);
        ObjectSet("X632", OBJPROP_XDISTANCE, 1072 + Table.X.Offset);
        ObjectSet("X632", OBJPROP_YDISTANCE, 30 + Table.Y.Offset);        

ObjectCreate("X631", OBJ_LABEL, 0, 0, 0);
        ObjectSetText("X631",DoubleToStr(LDAILY,Digits), 13, "Arial Bold", White);
        ObjectSet("X631", OBJPROP_CORNER, 2);
        ObjectSet("X631", OBJPROP_XDISTANCE, 1132 + Table.X.Offset);
        ObjectSet("X631", OBJPROP_YDISTANCE, 30 + Table.Y.Offset);
        
ObjectCreate("X640", OBJ_LABEL, 0, 0, 0);
        ObjectSetText("X640",TimeToStr(LocalTime()), 13, "Arial Bold", Silver);
        ObjectSet("X640", OBJPROP_CORNER, 2);
        ObjectSet("X640", OBJPROP_XDISTANCE, 1065 + Table.X.Offset);
        ObjectSet("X640", OBJPROP_YDISTANCE, 7 + Table.Y.Offset);        

//1st Octave column plus Algorithm
m0 = (MathFloor(xard/(fractal/column1))*(fractal/column1));
m8 = m0+((fractal/octave1)*8);
m7 = m0+((fractal/octave1)*7);
m6 = m0+((fractal/octave1)*6);
m5 = m0+((fractal/octave1)*5);
m4 = m0+((fractal/octave1)*4);
m3 = m0+((fractal/octave1)*3);
m2 = m0+((fractal/octave1)*2);
m1 = m0+((fractal/octave1)*1);

//2nd Octave column plus Algorithm
mm0 = (MathFloor(xard/(fractal/column2))*(fractal/column2));
mm8 = mm0+((fractal/octave2)*8);
mm7 = mm0+((fractal/octave2)*7);
mm6 = mm0+((fractal/octave2)*6);
mm5 = mm0+((fractal/octave2)*5);
mm4 = mm0+((fractal/octave2)*4);
mm3 = mm0+((fractal/octave2)*3);
mm2 = mm0+((fractal/octave2)*2);
mm1 = mm0+((fractal/octave2)*1);
mm11 =mm0-((fractal/octave2)*1);
mm12 =mm0-((fractal/octave2)*2);
mm13 =mm0+((fractal/octave2)*9);
mm14 =mm0+((fractal/octave2)*10);
mm15 =mm0+((fractal/octave2)*11);
mm16 =mm0+((fractal/octave2)*12);
mm17 =mm0-((fractal/octave2)*3);
mm18 =mm0-((fractal/octave2)*4);

//3rd Octave Column plus Algorithm
mm30 = (MathFloor(xard/(fractal/column3))*(fractal/column3));
mm31 = mm30+((fractal/octave3)*1);
mm32 = mm30+((fractal/octave3)*2);
mm33 = mm30+((fractal/octave3)*3);
mm34 = mm30+((fractal/octave3)*4);
mm35 = mm30+((fractal/octave3)*5);
mm36 = mm30+((fractal/octave3)*6);
mm37 = mm30+((fractal/octave3)*7);
mm38 = mm30+((fractal/octave3)*8);
mm3P1 = mm30+((fractal/octave3)*9);
mm3P2 = mm30+((fractal/octave3)*10);
mm3M1 = mm30-((fractal/octave3)*1);
mm3M2 = mm30-((fractal/octave3)*2);
mm313 = mm30+((fractal/octave3)*11);
mm314 = mm30+((fractal/octave3)*12);
mm315 = mm30-((fractal/octave3)*3);
mm316 = mm30-((fractal/octave3)*4);
    
// Calculating Our TimeFrame    
   range=(v2-v1);
   sum=MathFloor(MathLog(fractal/range)/MathLog(2));
   octave=fractal*(MathPow(0.5,sum));
   mn=MathFloor(v1/octave)*octave;
   if( (mn+octave)>v2 )
   mx=mn+octave; 
   else
     mx=mn+(2*octave);

// calculating xx
//x2
    if( (v1>=(3*(mx-mn)/16+mn)) && (v2<=(9*(mx-mn)/16+mn)) )
    x2=mn+(mx-mn)/2; 
    else x2=0;
//x1
    if( (v1>=(mn-(mx-mn)/8))&& (v2<=(5*(mx-mn)/8+mn)) && (x2==0) )
    x1=mn+(mx-mn)/2; 
    else x1=0;

//x4
    if( (v1>=(mn+7*(mx-mn)/16))&& (v2<=(13*(mx-mn)/16+mn)) )
    x4=mn+3*(mx-mn)/4; 
    else x4=0;

//x5
    if( (v1>=(mn+3*(mx-mn)/8))&& (v2<=(9*(mx-mn)/8+mn))&& (x4==0) )
    x5=mx; 
    else  x5=0;

//x3
    if( (v1>=(mn+(mx-mn)/8))&& (v2<=(7*(mx-mn)/8+mn))&& (x1==0) && (x2==0) && (x4==0) && (x5==0) )
    x3=mn+3*(mx-mn)/4; 
    else x3=0;

//x6
    if( (x1+x2+x3+x4+x5) ==0 )
    x6=mx; 
    else x6=0;

     finalH = x1+x2+x3+x4+x5+x6;
// calculating yy
//y1
    if( x1>0 )
    y1=mn; 
    else y1=0;

//y2
    if( x2>0 )
    y2=mn+(mx-mn)/4; 
    else y2=0;

//y3
    if( x3>0 )
    y3=mn+(mx-mn)/4; 
    else y3=0;

//y4
    if( x4>0 )
    y4=mn+(mx-mn)/2; 
    else y4=0;

//y5
    if( x5>0 )
    y5=mn+(mx-mn)/2; 
    else y5=0;

//y6
    if( (finalH>0) && ((y1+y2+y3+y4+y5)==0) )
    y6=mn; 
    else y6=0;

    finalL = y1+y2+y3+y4+y5+y6;

    for( i=0; i<OctLinesCnt; i++) {
         mml[i] = 0;
         }
         
   dmml = (finalH-finalL)/8;


if (Frame) {
   mml[0] =(finalL-dmml*2); //-2/8
   for( i=1; i<OctLinesCnt; i++) {
        mml[i] = mml[i-1] + dmml;
        }
   for( i=0; i<OctLinesCnt; i++ ){
        buff_str = "mml"+i;
        if(ObjectFind(buff_str) == -1) {
           ObjectCreate(buff_str, OBJ_HLINE, 0, BlockEnd, mml[i]);
           ObjectSet(buff_str, OBJPROP_STYLE, STYLE_SOLID);
           ObjectSet(buff_str, OBJPROP_COLOR, mml_clr[i]);
           ObjectSet(buff_str, OBJPROP_RAY, false);
           ObjectSet(buff_str, OBJPROP_WIDTH,1);
           ObjectMove(buff_str, 0, BlockEnd ,  mml[i]);
           }
        else {
           ObjectMove(buff_str, 0, BlockEnd,  mml[i]);
           } 
        buff_str = "mml_txt"+i;
        if(ObjectFind(buff_str) == -1) {
           ObjectCreate(buff_str, OBJ_TEXT, 0, Time[mml_shft], mml_shft);
           if (Text.Color.Line) {
               ObjectSetText(buff_str, ln_txt[i], Font.Size, "Verdana Bold", mml_clr[i]);
            } else {
               ObjectSetText(buff_str, ln_txt[i], Font.Size, "Verdana Bold", Text.Color);
            }
           //ObjectSetText(buff_str, DoubleToStr(mml[i],Digits), 9, "Verdana", mml_clr[i]);
           ObjectMove(buff_str, 0, Time[mml_shft],  mml[i]);  // original Time[mml_shft]
           }
        else {
           ObjectMove(buff_str, 0, Time[mml_shft],  mml[i]);     // original Time[mml_shft]
           }
           buff_str = "mml2_txt"+i;
        if(ObjectFind(buff_str) == -1) {
           ObjectCreate(buff_str, OBJ_TEXT, 0, Time[mml_shft], mml_shft);
           //ObjectSetText(buff_str, ln_txt[i], 9, "Verdana", mml_clr[i]);
           if (Text.Color.Line) {
              ObjectSetText(buff_str, DoubleToStr(mml[i],Digits), Font.Size, "Verdana Bold", mml_clr[i]);
           } else {
              ObjectSetText(buff_str, DoubleToStr(mml[i],Digits), Font.Size, "Verdana", Text.Color);
           } 
           ObjectMove(buff_str, 0, Time[mml_shft],  mml[i]);   // original Time[mml_shft]
           }
        else {
           ObjectMove(buff_str, 0, Time[mml_shft],  mml[i]);  /// original Time[mml_shft]
           }
     }      
           
        } // for( i=1; i<=OctLinesCnt; i++ ){
//Comment("\n"," ");
   nTime    = Time[0];
   CurPeriod= Period();

//Baby Lines
double bm222,bm224,bm226;
double bm112,bm114,bm116;
double bm02,bm04,bm06;
double bm12,bm14,bm16;
double bm22,bm24,bm26;
double bm32,bm34,bm36;
double bm42,bm44,bm46;
double bm52,bm54,bm56;
double bm62,bm64,bm66;
double bm72,bm74,bm76;
double bm82,bm84,bm86;
double bm92,bm94,bm96;

bm222 = ((mml[1]-mml[0])/4)+mml[0];
bm224 = ((mml[1]-mml[0])/2)+mml[0];
bm226 = ((mml[1]-mml[0])/4)*3+mml[0];

bm112 = ((mml[2]-mml[1])/4)+mml[1];
bm114 = ((mml[2]-mml[1])/2)+mml[1];
bm116 = ((mml[2]-mml[1])/4)*3+mml[1];

bm02 = ((mml[3]-mml[2])/4)+mml[2];
bm04 = ((mml[3]-mml[2])/2)+mml[2];
bm06 = ((mml[3]-mml[2])/4)*3+mml[2];

bm12 = ((mml[4]-mml[3])/4)+mml[3];
bm14 = ((mml[4]-mml[3])/2)+mml[3];
bm16 = ((mml[4]-mml[3])/4)*3+mml[3];

bm22 = ((mml[5]-mml[4])/4)+mml[4];
bm24 = ((mml[5]-mml[4])/2)+mml[4];
bm26 = ((mml[5]-mml[4])/4)*3+mml[4];

bm32 = ((mml[6]-mml[5])/4)+mml[5];
bm34 = ((mml[6]-mml[5])/2)+mml[5];
bm36 = ((mml[6]-mml[5])/4)*3+mml[5];

bm42 = ((mml[7]-mml[6])/4)+mml[6];
bm44 = ((mml[7]-mml[6])/2)+mml[6];
bm46 = ((mml[7]-mml[6])/4)*3+mml[6];

bm52 = ((mml[8]-mml[7])/4)+mml[7];
bm54 = ((mml[8]-mml[7])/2)+mml[7];
bm56 = ((mml[8]-mml[7])/4)*3+mml[7];

bm62 = ((mml[9]-mml[8])/4)+mml[8];
bm64 = ((mml[9]-mml[8])/2)+mml[8];
bm66 = ((mml[9]-mml[8])/4)*3+mml[8];

bm72 = ((mml[10]-mml[9])/4)+mml[9];
bm74 = ((mml[10]-mml[9])/2)+mml[9];
bm76 = ((mml[10]-mml[9])/4)*3+mml[9];

bm82 = ((mml[11]-mml[10])/4)+mml[10];
bm84 = ((mml[11]-mml[10])/2)+mml[10];
bm86 = ((mml[11]-mml[10])/4)*3+mml[10];

bm92 = ((mml[12]-mml[11])/4)+mml[11];
bm94 = ((mml[12]-mml[11])/2)+mml[11];
bm96 = ((mml[12]-mml[11])/4)*3+mml[11];

//Calculating Pivots
double rates[1][6],yesterday_close,yesterday_high,yesterday_low;
ArrayCopyRates(rates, Symbol(), PERIOD_D1);

if(DayOfWeek() == 1)
{
   if(TimeDayOfWeek(iTime(Symbol(),PERIOD_D1,1)) == 5)
   {
       yesterday_close = rates[1][4];
       yesterday_high = rates[1][3];
       yesterday_low = rates[1][2];
   }
   else
   {
      for(int d = 5;d>=0;d--)
      {
         if(TimeDayOfWeek(iTime(Symbol(),PERIOD_D1,d)) == 5)
         {
             yesterday_close = rates[d][4];
             yesterday_high = rates[d][3];
             yesterday_low = rates[d][2];
         }
         
      }  
      
   }
}
else
{
    yesterday_close = rates[1][4];
    yesterday_high = rates[1][3];
    yesterday_low = rates[1][2];
}


//---- Calculate Pivots

/*double R = yesterday_high - yesterday_low;//range
double p = (yesterday_high + yesterday_low + yesterday_close)/3;// Standard Pivot
double r3 = (2*p)+(yesterday_high-(2*yesterday_low));
double r2 = p+(yesterday_high - yesterday_low);
double r1 = (2*p)-yesterday_low;
double s1 = (2*p)-yesterday_high;
double s2 = p-(yesterday_high - yesterday_low);
double s3 = (2*p)-((2* yesterday_high)-yesterday_low);*/
double yc = yesterday_close;

CreateObj3(FF1, mml[2], mml[10], MMColor);
CreateObj3(FF2, mml[0], mml[2], MM2Color);
CreateObj3(FF3, mml[12], mml[10], MM2Color);
CreateObj3(YC, yc, yc, Silver);

// Draw Time Lines here
if (TimeLines) {
   DrawTimePoints();
}
  
// Draw Boxes at time points
if (Day.Boxes) {
   dt=CurTime();
   for (d=0; d<NumberOfDays; d++) {
      DrawObjects(dt, "PWT1"+d, Begin_1, End_1);
      DrawObjects(dt, "PWT2"+d, Begin_2, End_2);
      dt=decDateTradeDay(dt);
      while (TimeDayOfWeek(dt)>5) dt=decDateTradeDay(dt);
   }
}

ObjectsRedraw(); 

// --- Typing Labels
//yc label
if (Show.Yesterdays.Close) {
   if(ObjectFind("yc label") != 0)
      {
      ObjectCreate("yc label", OBJ_TEXT, 0, Time[15], yc);
      ObjectSetText("yc label", " Yesterday Close "+DoubleToStr(yc,Digits), 8, "Arial", Silver);
   }
   else
   {
      ObjectMove("yc label", 0, Time[15], yc);
   }
   
   ObjectDelete("yc_Line");
   ObjectCreate("yc_Line", OBJ_HLINE,0, BlockEnd,yc);
   ObjectSet("yc_Line",OBJPROP_COLOR,Silver);
   ObjectSet("yc_Line",OBJPROP_STYLE,STYLE_DASH);
   ObjectSet("yc_Line",OBJPROP_RAY, false);
   ObjectSet("yc_Line",OBJPROP_WIDTH,1);  
}

//Baby 2 Column
if (BabyLines) {

ObjectDelete("bm222_Line");
ObjectCreate("bm222_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm222);
ObjectSet("bm222_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm222_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm222_Line",OBJPROP_RAY, false);
ObjectSet("bm222_Line",OBJPROP_WIDTH,0);  
 
ObjectDelete("bm224_Line");
ObjectCreate("bm224_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm224);
ObjectSet("bm224_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm224_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm224_Line",OBJPROP_RAY,false);
ObjectSet("bm224_Line",OBJPROP_WIDTH,0);

ObjectDelete("bm226_Line");
ObjectCreate("bm226_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm226);
ObjectSet("bm226_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm226_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm226_Line",OBJPROP_RAY,false);
ObjectSet("bm226_Line",OBJPROP_WIDTH,0); 

ObjectDelete("bm112_Line");
ObjectCreate("bm112_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm112);
ObjectSet("bm112_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm112_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm112_Line",OBJPROP_RAY,false);
ObjectSet("bm112_Line",OBJPROP_WIDTH,0);  
 
ObjectDelete("bm114_Line");
ObjectCreate("bm114_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm114);
ObjectSet("bm114_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm114_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm114_Line",OBJPROP_RAY,false);
ObjectSet("bm114_Line",OBJPROP_WIDTH,0);

ObjectDelete("bm116_Line");
ObjectCreate("bm116_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm116);
ObjectSet("bm116_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm116_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm116_Line",OBJPROP_RAY,false);
ObjectSet("bm116_Line",OBJPROP_WIDTH,0); 

ObjectDelete("bm02_Line");
ObjectCreate("bm02_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm02);
ObjectSet("bm02_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm02_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm02_Line",OBJPROP_RAY,false);
ObjectSet("bm02_Line",OBJPROP_WIDTH,0);  
 
ObjectDelete("bm04_Line");
ObjectCreate("bm04_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm04);
ObjectSet("bm04_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm04_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm04_Line",OBJPROP_RAY,false);
ObjectSet("bm04_Line",OBJPROP_WIDTH,0);

ObjectDelete("bm06_Line");
ObjectCreate("bm06_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm06);
ObjectSet("bm06_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm06_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm06_Line",OBJPROP_RAY,false);
ObjectSet("bm06_Line",OBJPROP_WIDTH,0); 

ObjectDelete("bm12_Line");
ObjectCreate("bm12_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm12);
ObjectSet("bm12_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm12_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm12_Line",OBJPROP_RAY,false);
ObjectSet("bm12_Line",OBJPROP_WIDTH,0);  
 
ObjectDelete("bm14_Line");
ObjectCreate("bm14_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm14);
ObjectSet("bm14_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm14_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm14_Line",OBJPROP_RAY,false);
ObjectSet("bm14_Line",OBJPROP_WIDTH,0);

ObjectDelete("bm16_Line");
ObjectCreate("bm16_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm16);
ObjectSet("bm16_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm16_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm16_Line",OBJPROP_RAY,false);
ObjectSet("bm16_Line",OBJPROP_WIDTH,0); 

ObjectDelete("bm22_Line");
ObjectCreate("bm22_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm22);
ObjectSet("bm22_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm22_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm22_Line",OBJPROP_RAY,false);
ObjectSet("bm22_Line",OBJPROP_WIDTH,0);  
 
ObjectDelete("bm24_Line");
ObjectCreate("bm24_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm24);
ObjectSet("bm24_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm24_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm24_Line",OBJPROP_RAY,false);
ObjectSet("bm24_Line",OBJPROP_WIDTH,0);

ObjectDelete("bm26_Line");
ObjectCreate("bm26_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm26);
ObjectSet("bm26_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm26_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm26_Line",OBJPROP_RAY,false);
ObjectSet("bm26_Line",OBJPROP_WIDTH,0);  

ObjectDelete("bm32_Line");
ObjectCreate("bm32_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm32);
ObjectSet("bm32_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm32_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm32_Line",OBJPROP_RAY,false);
ObjectSet("bm32_Line",OBJPROP_WIDTH,0);  
 
ObjectDelete("bm34_Line");
ObjectCreate("bm34_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm34);
ObjectSet("bm34_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm34_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm34_Line",OBJPROP_RAY,false);
ObjectSet("bm34_Line",OBJPROP_WIDTH,0);

ObjectDelete("bm36_Line");
ObjectCreate("bm36_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm36);
ObjectSet("bm36_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm36_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm36_Line",OBJPROP_RAY,false);
ObjectSet("bm36_Line",OBJPROP_WIDTH,0);  

ObjectDelete("bm42_Line");
ObjectCreate("bm42_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm42);
ObjectSet("bm42_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm42_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm42_Line",OBJPROP_RAY,false);
ObjectSet("bm42_Line",OBJPROP_WIDTH,0);  
 
ObjectDelete("bm44_Line");
ObjectCreate("bm44_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm44);
ObjectSet("bm44_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm44_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm44_Line",OBJPROP_RAY,false);
ObjectSet("bm44_Line",OBJPROP_WIDTH,0);

ObjectDelete("bm46_Line");
ObjectCreate("bm46_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm46);
ObjectSet("bm46_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm46_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm46_Line",OBJPROP_RAY,false);
ObjectSet("bm46_Line",OBJPROP_WIDTH,0);  

ObjectDelete("bm52_Line");
ObjectCreate("bm52_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm52);
ObjectSet("bm52_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm52_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm52_Line",OBJPROP_RAY,false);
ObjectSet("bm52_Line",OBJPROP_WIDTH,0);  
 
ObjectDelete("bm54_Line");
ObjectCreate("bm54_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm54);
ObjectSet("bm54_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm54_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm54_Line",OBJPROP_RAY,false);
ObjectSet("bm54_Line",OBJPROP_WIDTH,0);

ObjectDelete("bm56_Line");
ObjectCreate("bm56_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm56);
ObjectSet("bm56_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm56_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm56_Line",OBJPROP_RAY,false);
ObjectSet("bm56_Line",OBJPROP_WIDTH,0);  

ObjectDelete("bm62_Line");
ObjectCreate("bm62_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm62);
ObjectSet("bm62_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm62_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm62_Line",OBJPROP_RAY,false);
ObjectSet("bm62_Line",OBJPROP_WIDTH,0);  
 
ObjectDelete("bm64_Line");
ObjectCreate("bm64_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm64);
ObjectSet("bm64_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm64_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm64_Line",OBJPROP_RAY,false);
ObjectSet("bm64_Line",OBJPROP_WIDTH,0);

ObjectDelete("bm66_Line");
ObjectCreate("bm66_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm66);
ObjectSet("bm66_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm66_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm66_Line",OBJPROP_RAY,false);
ObjectSet("bm66_Line",OBJPROP_WIDTH,0);

ObjectDelete("bm72_Line");
ObjectCreate("bm72_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm72);
ObjectSet("bm72_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm72_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm72_Line",OBJPROP_RAY,false);
ObjectSet("bm72_Line",OBJPROP_WIDTH,0);  
 
ObjectDelete("bm74_Line");
ObjectCreate("bm74_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm74);
ObjectSet("bm74_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm74_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm74_Line",OBJPROP_RAY,false);
ObjectSet("bm74_Line",OBJPROP_WIDTH,0);

ObjectDelete("bm76_Line");
ObjectCreate("bm76_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm76);
ObjectSet("bm76_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm76_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm76_Line",OBJPROP_RAY,false);
ObjectSet("bm76_Line",OBJPROP_WIDTH,0);

ObjectDelete("bm82_Line");
ObjectCreate("bm82_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm82);
ObjectSet("bm82_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm82_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm82_Line",OBJPROP_RAY,false);
ObjectSet("bm82_Line",OBJPROP_WIDTH,0);  
 
ObjectDelete("bm84_Line");
ObjectCreate("bm84_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm84);
ObjectSet("bm84_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm84_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm84_Line",OBJPROP_RAY,false);
ObjectSet("bm84_Line",OBJPROP_WIDTH,0);

ObjectDelete("bm86_Line");
ObjectCreate("bm86_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm86);
ObjectSet("bm86_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm86_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm86_Line",OBJPROP_RAY,false);
ObjectSet("bm86_Line",OBJPROP_WIDTH,0);
 
ObjectDelete("bm92_Line");
ObjectCreate("bm92_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm92);
ObjectSet("bm92_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm92_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm92_Line",OBJPROP_RAY,false);
ObjectSet("bm92_Line",OBJPROP_WIDTH,0);  
 
ObjectDelete("bm94_Line");
ObjectCreate("bm94_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm94);
ObjectSet("bm94_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm94_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm94_Line",OBJPROP_RAY,false);
ObjectSet("bm94_Line",OBJPROP_WIDTH,0);

ObjectDelete("bm96_Line");
ObjectCreate("bm96_Line", OBJ_TRENDBYANGLE,0, BlockEnd,bm96);
ObjectSet("bm96_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm96_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm96_Line",OBJPROP_RAY,false);
ObjectSet("bm96_Line",OBJPROP_WIDTH,0);

}

if (MMTables) {
   drawLabel24("MK24","TimeFrame",9,White,5,25,"Arial Bold");
   drawLabel25("MK25","MML",9,White,5,25,"Arial Bold");
   drawLabel26("MK26","mML",9,White,5,25,"Arial Bold");
   drawLabel27("MK27","Octave",9,White,5,25,"Arial Bold");
   drawLabel30("MK30","0/8th",8,White,5,25,"Arial");
   drawLabel31("MK31","1/8th",8,White,5,25,"Arial");
   drawLabel32("MK32","2/8th",8,White,5,25,"Arial");
   drawLabel33("MK33","3/8th",8,White,5,25,"Arial");
   drawLabel34("MK34","4/8th",8,White,5,25,"Arial");
   drawLabel35("MK35","5/8th",8,White,5,25,"Arial");
   drawLabel36("MK36","6/8th",8,White,5,25,"Arial");
   drawLabel37("MK37","7/8th",8,White,5,25,"Arial");
   drawLabel38("MK38","8/8th",8,White,5,25,"Arial");
   drawLabel39("MK39","+1/8th",8,White,5,25,"Arial");
   drawLabel40("MK40","+2/8th",8,White,5,25,"Arial");
   drawLabel41("MK41","-1/8th",8,White,5,25,"Arial");
   drawLabel42("MK42","-2/8th",8,White,5,25,"Arial");
   
   drawLabel000("MK000",DoubleToStr(m0,Digits),Table.Font.Size,DodgerBlue,5,25,"Arial Bold");
   drawLabel001("MK001",DoubleToStr(m1,Digits),Table.Font.Size,Yellow,5,25,"Arial Bold");
   drawLabel002("MK002",DoubleToStr(m2,Digits),Table.Font.Size,HotPink,5,25,"Arial Bold");
   drawLabel003("MK003",DoubleToStr(m3,Digits),Table.Font.Size,Lime,5,25,"Arial Bold");
   drawLabel004("MK004",DoubleToStr(m4,Digits),Table.Font.Size,DodgerBlue,5,25,"Arial Bold");
   drawLabel005("MK005",DoubleToStr(m5,Digits),Table.Font.Size,Lime,5,25,"Arial Bold");
   drawLabel006("MK006",DoubleToStr(m6,Digits),Table.Font.Size,HotPink,5,25,"Arial Bold");
   drawLabel007("MK007",DoubleToStr(m7,Digits),Table.Font.Size,Yellow,5,25,"Arial Bold");
   drawLabel008("MK008",DoubleToStr(m8,Digits),Table.Font.Size,DodgerBlue,5,25,"Arial Bold");
   drawLabel08("MK08",DoubleToStr(mm11,Digits),Table.Font.Size,Yellow,5,25,"Arial Bold");
   drawLabel09("MK09",DoubleToStr(mm12,Digits),Table.Font.Size,HotPink,5,25,"Arial Bold");
   
   drawLabel1001("MK0001",DoubleToStr(mm0,Digits),Table.Font.Size,DodgerBlue,5,25,"Arial Bold");
   drawLabel1002("MK0002",DoubleToStr(mm1,Digits),Table.Font.Size,Yellow,5,25,"Arial Bold");
   drawLabel1003("MK0003",DoubleToStr(mm2,Digits),Table.Font.Size,HotPink,5,25,"Arial Bold");
   drawLabel1004("MK0004",DoubleToStr(mm3,Digits),Table.Font.Size,Lime,5,25,"Arial Bold");
   drawLabel1005("MK0005",DoubleToStr(mm4,Digits),Table.Font.Size,DodgerBlue,5,25,"Arial Bold");
   drawLabel1006("MK0006",DoubleToStr(mm5,Digits),Table.Font.Size,Lime,5,25,"Arial Bold");
   drawLabel1007("MK0007",DoubleToStr(mm6,Digits),Table.Font.Size,HotPink,5,25,"Arial Bold");
   drawLabel1008("MK0008",DoubleToStr(mm7,Digits),Table.Font.Size,Yellow,5,25,"Arial Bold");
   drawLabel1009("MK0009",DoubleToStr(mm8,Digits),Table.Font.Size,DodgerBlue,5,25,"Arial Bold");
   drawLabel1009b("MK0009b",DoubleToStr(mm13,Digits),Table.Font.Size,Yellow,5,25,"Arial Bold");
   drawLabel1009c("MK0009c",DoubleToStr(mm14,Digits),Table.Font.Size,HotPink,5,25,"Arial Bold");

   drawLabela00("MKa00",DoubleToStr(mm30,Digits),Table.Font.Size,DodgerBlue,5,25,"Arial Bold");
   drawLabelam1("MKam1",DoubleToStr(mm3M1,Digits),Table.Font.Size,Yellow,5,25,"Arial Bold");
   drawLabelam2("MKam2",DoubleToStr(mm3M2,Digits),Table.Font.Size,HotPink,5,25,"Arial Bold");
   drawLabela1("MKa1",DoubleToStr(mm31,Digits),Table.Font.Size,Yellow,5,25,"Arial Bold");
   drawLabela2("MKa2",DoubleToStr(mm32,Digits),Table.Font.Size,HotPink,5,25,"Arial Bold");
   drawLabela3("MKa3",DoubleToStr(mm33,Digits),Table.Font.Size,Lime,5,25,"Arial Bold");
   drawLabela4("MKa4",DoubleToStr(mm34,Digits),Table.Font.Size,DodgerBlue,5,25,"Arial Bold");
   drawLabela5("MKa5",DoubleToStr(mm35,Digits),Table.Font.Size,Lime,5,25,"Arial Bold");
   drawLabela6("MKa6",DoubleToStr(mm36,Digits),Table.Font.Size,HotPink,5,25,"Arial Bold");
   drawLabela7("MKa7",DoubleToStr(mm37,Digits),Table.Font.Size,Yellow,5,25,"Arial Bold");
   drawLabela8("MKa8",DoubleToStr(mm38,Digits),Table.Font.Size,DodgerBlue,5,25,"Arial Bold");
   drawLabela9("MKa9",DoubleToStr(mm3P1,Digits),Table.Font.Size,Yellow,5,25,"Arial Bold");
   drawLabela10("MKa10",DoubleToStr(mm3P2,Digits),Table.Font.Size,HotPink,5,25,"Arial Bold");
   
   drawLabel301("MK301","0/8th",8,White,5,25,"Arial");
   drawLabel311("MK311","1/8th",8,White,5,25,"Arial");
   drawLabel321("MK321","2/8th",8,White,5,25,"Arial");
   drawLabel331("MK331","3/8th",8,White,5,25,"Arial");
   drawLabel341("MK341","4/8th",8,White,5,25,"Arial");
   drawLabel351("MK351","5/8th",8,White,5,25,"Arial");
   drawLabel361("MK361","6/8th",8,White,5,25,"Arial");
   drawLabel371("MK371","7/8th",8,White,5,25,"Arial");
   drawLabel381("MK381","8/8th",8,White,5,25,"Arial");
   drawLabel391("MK391","+1/8th",8,White,5,25,"Arial");
   drawLabel401("MK401","+2/8th",8,White,5,25,"Arial");
   drawLabel411("MK411","-1/8th",8,White,5,25,"Arial");
   drawLabel421("MK421","-2/8th",8,White,5,25,"Arial");
   
   drawLabelz0("z0",DoubleToStr(mml[0],Digits),Table.Font.Size,Red,5,25,"Arial Bold");
   drawLabelz1("z1",DoubleToStr(mml[1],Digits),Table.Font.Size,OrangeRed,5,25,"Arial Bold");
   drawLabelz2("z2",DoubleToStr(mml[2],Digits),Table.Font.Size,DodgerBlue,5,25,"Arial Bold");
   drawLabelz3("z3",DoubleToStr(mml[3],Digits),Table.Font.Size,Yellow,5,25,"Arial Bold");
   drawLabelz4("z4",DoubleToStr(mml[4],Digits),Table.Font.Size,HotPink,5,25,"Arial Bold");
   drawLabelz5("z5",DoubleToStr(mml[5],Digits),Table.Font.Size,Lime,5,25,"Arial Bold");
   drawLabelz6("z6",DoubleToStr(mml[6],Digits),Table.Font.Size,DodgerBlue,5,25,"Arial Bold");
   drawLabelz7("z7",DoubleToStr(mml[7],Digits),Table.Font.Size,Lime,5,25,"Arial Bold");
   drawLabelz8("z8",DoubleToStr(mml[8],Digits),Table.Font.Size,HotPink,5,25,"Arial Bold");
   drawLabelz9("z9",DoubleToStr(mml[9],Digits),Table.Font.Size,Yellow,5,25,"Arial Bold");
   drawLabelz10("z10",DoubleToStr(mml[10],Digits),Table.Font.Size,DodgerBlue,5,25,"Arial Bold");
   drawLabelz11("z11",DoubleToStr(mml[11],Digits),Table.Font.Size,OrangeRed,5,25,"Arial Bold");
   drawLabelz12("z12",DoubleToStr(mml[12],Digits),Table.Font.Size,Red,5,25,"Arial Bold");
   }
   
   
   drawLabelsymbol("symbol",Symbol(),20,Silver,5,25,"Arial Bold");
   
   
ObjectsRedraw();  
  
//   }
/*
if (Fractals) {
Comment("                                                              ::::: Original Fractal Settings ::::"," Price: ",xard," :::: DateTime: ",TimeToStr(LocalTime())," :::: TimeFrame-2007-v0.04 ::::: ");
 }

if (Fractals == false) { 
Comment("                                                              ::::: Experimental Fractal Settings ::::"," Price: ",xard," :::: DateTime: ",TimeToStr(LocalTime())," :::: TimeFrame-2007-v0.04 ::::: ");
 } */

//---- End Of Program

  return(0);
  }
//Job Done  
//+------------------------------------------------------------------+
//*

void CreateObj3(string objName3, double start, double end, color clr) {
   ObjectCreate(objName3, OBJ_RECTANGLE, 0, BlockStart, start, BlockEnd, end);
   ObjectSet(objName3, OBJPROP_COLOR, clr);
}

// Day Box Init
void DayBoxInit() {
  DeleteObjects();
  for (d=0; d<NumberOfDays; d++) {
    CreateObjects("PWT1"+d, Color_1);
    CreateObjects("PWT2"+d, Color_2);
  }
}

        
//*/


// .. Time Functions
 
// Calculate Future Bar 
datetime FutureBarTime(int xbar) {
   int bar.seconds,add.bars;
   datetime past.bar.time,future.time;
   
   bar.seconds = Period()*60;
   // Start counting from bar one to future
   if (xbar > -1) xbar=-1;
   
   add.bars = MathAbs(1 - xbar);
   past.bar.time = iTime(Symbol(),Period(),1);  // bar before current Bar
   future.time = past.bar.time + (add.bars * bar.seconds);
   return(future.time);
}
  
int FutureTimeBar(datetime xtime) {
   int bar.seconds,add.time;
   int future.bar;
   
   bar.seconds = Period()*60;
   // Start counting from bar one to future
   if (xtime < CurTime()) xtime=CurTime();
   
   add.time = xtime;
   //past.bar.time = iTime(Symbol(),Period(),1);  // bar before current Bar
   future.bar = -(xtime - CurTime()) / bar.seconds;
   return(future.bar);
}

void DrawTimePoints() {
   int t.list,i;
   i=0;
   t.list = ArraySize(TimePointObjects);
   //Delete Objects from chart 
   for (i=t.list-1;i>=0;i--) {
      if (StringLen(TimePointObjects[i]) > 5) {
         ObjectDelete(TimePointObjects[i]);
      }
   }
   // Draw new points
   i=0;
   while (i < t.list) {
      if (!intra.day.lines) {
         if (i > 8) { break; }
      } else {
         if (Period() > PERIOD_M30 && i > 8) {break;}
      }
      ObjectCreate(TimePointObjects[i],OBJ_VLINE,0, 0,0, 0,0);
      ObjectSet(TimePointObjects[i], OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet(TimePointObjects[i], OBJPROP_WIDTH, 1);
      ObjectSet(TimePointObjects[i], OBJPROP_COLOR, TimePointColor[i]);
      ObjectSet(TimePointObjects[i],OBJPROP_TIME1,TimePointTime[i]);
      i++;
   }
   return(0);
}    

void TimePointProcess(string& tpO[],datetime& tpT[],color& tpC[]) {
   string myLabel,xLine;
   myLabel= StringConcatenate(Symbol(), Period());
    
   // Default Trading Frame if not 256,64,32,16 ,8 ,4 ...Days
   if (TradingFrame != 4 && TradingFrame != 8 && TradingFrame != 16 &&
         TradingFrame != 32 && TradingFrame != 64 && TradingFrame != 256) {
      TradingFrame = 4;
   }
   int day.pos=0;
   int z=0;
   int limit=0;
   int one.day=(1440*60);
   int day.offset.int=0;
   int chk.first = 0;
   int day.interval=TradingFrame/4;
   int inter.change;
   double day.increment,day.offset.double,chk.odd;
   datetime end.day,start.day,compare.end;
   datetime x.now=CurTime();
   datetime cCurrent,x.date;
   string intra.day.start.time=StringConcatenate(TimeToStr(CurTime(),TIME_DATE)," ",
            TimeToStr(HM.Date,TIME_MINUTES));
   day.increment=day.interval;
   day.increment = day.increment/2;
   day.offset.double = Day.Offset;
   day.offset.double = MathAbs(day.offset.double);
   day.offset.int = day.offset.double;
   
   // Find Start poistion
   start.day = FindFrameStart(TradingFrame);
   // Find start on day Increment Grid
   day.pos=ArrayBsearch(TimeGridByDay,start.day);
   // Process Day Offset
   if (Day.Offset != 0) {
      if (Day.Offset > 0) {
         if ((day.pos+day.offset.int) < ArraySize(TimeGridByDay)) {
            if (CurTime() > TimeGridByDay[day.pos+day.offset.int]) {
               start.day = TimeGridByDay[day.pos+day.offset.int];
               day.pos=day.pos+day.offset.int;
            }
         }
      } else {
         if ((day.pos-day.offset.int) >= 0) {
            start.day = TimeGridByDay[day.pos-day.offset.int];
            day.pos=day.pos-day.offset.int;
         }
      }
   }
   cCurrent = start.day;
   x.date = cCurrent;
   for( z=0; z<9; z++) {
      xLine = StringConcatenate("  ",z,"/8"); 
      if (z==0 || z==8) { tpC[z]=ZeroEight.8; }
      if (z==1 || z==7) { tpC[z]=OneSeven.8; }
      if (z==2 || z==6) { tpC[z]=TwoSix.8; }
      if (z==3 || z==5) { tpC[z]=ThreeFive.8; }
      if (z==4 ) { tpC[z]=Four.8; }
      
      if (TradingFrame > 4) {
         if (CurTime() > TimeGridByDay[day.pos]) {    // past vs. future
            cCurrent = TimeGridByDay[day.pos];
            tpT[z]= cCurrent;
            tpO[z]= StringConcatenate(myLabel, xLine,"-",TimeToStr(cCurrent,TIME_DATE|TIME_MINUTES));
            day.pos = day.pos + day.increment;
         } else {
            cCurrent = cCurrent + one.day*day.increment;
            tpT[z]= cCurrent;
            tpO[z]= StringConcatenate(myLabel, xLine,"-",TimeToStr(TimeGridByDay[day.pos],TIME_DATE|TIME_MINUTES));
            day.pos = day.pos + day.increment;
         }
      } else {
         if (cCurrent < CurTime() ) {
            tpO[z]= StringConcatenate(myLabel, xLine,"-",TimeToStr(cCurrent,TIME_DATE|TIME_MINUTES));
         } else {
            tpO[z]= StringConcatenate(myLabel, xLine,"-",TimeToStr(x.date,TIME_DATE|TIME_MINUTES));
         }
         tpT[z]= cCurrent;
         cCurrent = cCurrent + one.day*day.increment;
         x.date = x.date + one.day*day.increment;

         if (cCurrent < CurTime()) {
            cCurrent = xWeekEnds(cCurrent);  // skip weekends
            cCurrent = xHolidays(cCurrent);  // skip holidays
         } else {
            x.date = xWeekEnds(x.date);  // skip weekends
            x.date = xHolidays(x.date);  // skip holidays
         }
      }
   }
   // Establish static var block variables
   if (TradingFrame == 4) {
      cCurrent = cCurrent - one.day*day.increment;
   }
   BlockStart=start.day;
   BlockEnd=cCurrent;
   BlockEndText=FutureBarTime((FutureTimeBar(BlockEnd)+8));
   
   if (intra.day.lines && Period() <= PERIOD_H1) {
      cCurrent = StrToTime(intra.day.start.time);
      x.date=cCurrent;
      for( z=0; z<9; z++) {
         xLine = StringConcatenate("  baby ",z,"/8"); 
         if (z==0 || z==8) { tpC[z+9]=ZeroEight.8; }
         if (z==1 || z==7) { tpC[z+9]=OneSeven.8; }
         if (z==2 || z==6) { tpC[z+9]=TwoSix.8; }
         if (z==3 || z==5) { tpC[z+9]=ThreeFive.8; }
         if (z==4 ) { tpC[z+9]=Four.8; }
         
         if (cCurrent < CurTime() ) {
            tpO[z+9]= StringConcatenate(myLabel, xLine,"-",TimeToStr(cCurrent,TIME_DATE|TIME_MINUTES));
         } else {
            tpO[z+9]= StringConcatenate(myLabel, xLine,"-",TimeToStr(x.date,TIME_DATE|TIME_MINUTES));
         }
         tpT[z+9]= cCurrent;
         cCurrent = cCurrent + (180*60);
         x.date = x.date + (180*60);

         if (cCurrent < CurTime()) {
            cCurrent = xWeekEnds(cCurrent);  // skip weekends
            cCurrent = xHolidays(cCurrent);  // skip holidays
         } else {
            x.date = xWeekEnds(x.date);  // skip weekends
            x.date = xHolidays(x.date);  // skip holidays
         }
      }
   }
   return(0);
}

void LoadTimeGrid(datetime& T.Grid[], datetime& T.GridByDay[]) {
   int p=0;
   int s=0;
   int z.pos=0;
   int one.day=(1440*60);
   int four.days=one.day*4;
  
	bool isHoliday=False;
   datetime calcStart;

   // Create 4-Day Grid
   calcStart = HM.Date;
   T.Grid[0]=calcStart;
   T.GridByDay[0]=calcStart;
   while (p < 64) {

      for( s=0; s<4; s++) {
         calcStart = calcStart + one.day;
         // skip weekends
         calcStart = xWeekEnds(calcStart);
         // skip weekday holidays
         calcStart = xHolidays(calcStart);
         
         // Load Grid with days excluding weekends & holidays
         z.pos++;
         ArrayResize(T.GridByDay,z.pos+1);
         T.GridByDay[z.pos]=calcStart;
      }
 	   //--add to grid
	   p++;
      ArrayResize(T.Grid,p+1);
      T.Grid[p]=calcStart;
   }
	return(0);
}

datetime xWeekEnds(datetime w.time) {
   int a.day=(1440*60);
   if (TimeDayOfWeek(w.time)==6) {
       w.time = w.time + (a.day*2);
   }
   if (TimeDayOfWeek(w.time)==0) {
       w.time = w.time + a.day;
   }
   return (w.time);
}

datetime xHolidays(datetime h.time) {
   int a.day=(1440*60);
   bool isHoliday=False;
   // Add additional holidays if necessary  ... format : Month then day
   if (TimeMonth(h.time) == 12 && TimeDay(h.time) == 24) { isHoliday=True; }
   if (TimeMonth(h.time) == 1 && TimeDay(h.time) == 1) { isHoliday=True; }
   if (isHoliday) {
	   h.time = h.time + a.day;
   }
   return (h.time);
}

datetime FindFrameStart(int xFrame) {
   int xLimit,xCnt,s.pos,e.pos;
   datetime comp.date;
   
   xCnt = 0;
   xLimit = ArraySize(TimeGrid);
   while (xCnt < xLimit) {
      comp.date = TimeGrid[xCnt];
      s.pos=ArrayBsearch(TimeGridByDay,comp.date);
      e.pos=s.pos+xFrame;
      if (CurTime() < TimeGridByDay[e.pos]) {
         break;
      }
      xCnt = xCnt + (xFrame/4);
   }
   return (comp.date);
}

//--- Day Box Functions

void CreateObjects(string no, color cl) {
  ObjectCreate(no, OBJ_RECTANGLE, 0, 0,0, 0,0);
  ObjectSet(no, OBJPROP_STYLE, STYLE_SOLID);
  ObjectSet(no, OBJPROP_COLOR, cl);
  ObjectSet(no, OBJPROP_BACK, True);
}

void DeleteObjects() {
  for (d=0; d<NumberOfDays; d++) {
    ObjectDelete("PWT1"+d);
    ObjectDelete("PWT2"+d);
  }
}

void DrawObjects(datetime dt, string no, string tb, string te) {
  datetime t1, t2;
  double   p1, p2;
  int      b1, b2;

  t1=StrToTime(TimeToStr(dt, TIME_DATE)+" "+tb);
  t2=StrToTime(TimeToStr(dt, TIME_DATE)+" "+te);
  b1=iBarShift(NULL, 0, t1);
  b2=iBarShift(NULL, 0, t2);
  p1=High[Highest(NULL, 0, MODE_HIGH, b1-b2, b2)];
  p2=Low [Lowest (NULL, 0, MODE_LOW , b1-b2, b2)];
  if (!HighRange) {p1=0; p2=2*p2;}
  ObjectSet(no, OBJPROP_TIME1 , t1);
  ObjectSet(no, OBJPROP_PRICE1, p1);
  ObjectSet(no, OBJPROP_TIME2 , t2);
  ObjectSet(no, OBJPROP_PRICE2, p2);
}

datetime decDateTradeDay (datetime dt) {
  int ty=TimeYear(dt);
  int tm=TimeMonth(dt);
  int td=TimeDay(dt);
  int th=TimeHour(dt);
  int ti=TimeMinute(dt);

  td--;
  if (td==0) {
    tm--;
    if (tm==0) {
      ty--;
      tm=12;
    }
    if (tm==1 || tm==3 || tm==5 || tm==7 || tm==8 || tm==10 || tm==12) td=31;
    if (tm==2) if (MathMod(ty, 4)==0) td=29; else td=28;
    if (tm==4 || tm==6 || tm==9 || tm==11) td=30;
  }
  return(StrToTime(ty+"."+tm+"."+td+" "+th+":"+ti));
}
//+------------------------------------------------------------------+
void drawLabel30(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1039 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 170 + Table.Y.Offset);
        }} 
        
void drawLabel31(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1039 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 182 + Table.Y.Offset);
        }}  
  
void drawLabel32(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1039 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 194 + Table.Y.Offset);
        }}   
        
void drawLabel33(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1039 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 206 + Table.Y.Offset);
        }}                      
        
void drawLabel34(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1039 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 218 + Table.Y.Offset);
        }}   
        
void drawLabel35(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1039 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 230 + Table.Y.Offset);
        }} 
        
void drawLabel36(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1039 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 242 + Table.Y.Offset);
        }}   
        
void drawLabel37(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1039 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 254 + Table.Y.Offset);
        }}  
        
void drawLabel38(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1039 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 266 + Table.Y.Offset);
        }}  
        
void drawLabel39(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1088 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 282 + Table.Y.Offset);
        }}  
        
void drawLabel40(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1088 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 294 + Table.Y.Offset);
        }}   
        
void drawLabel41(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1092 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 154 + Table.Y.Offset);
        }}     
        
void drawLabel42(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1092 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 142 + Table.Y.Offset);
        }}                                                                               

void drawLabel25(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1075 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 308 + Table.Y.Offset);
        }} 
        
void drawLabel26(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1128 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 308 + Table.Y.Offset);
        }}  
        
void drawLabel27(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1175 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 308 + Table.Y.Offset);
        }}                


void drawLabela00(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1175 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 170 + Table.Y.Offset);
        }} 
        
void drawLabelam1(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1175 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 154 + Table.Y.Offset);
        }}        
        
void drawLabelam2(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1175 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 142 + Table.Y.Offset);
        }}    
        
void drawLabela1(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1175 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 182 + Table.Y.Offset);
        }} 
        
void drawLabela2(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1175 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 194 + Table.Y.Offset);
        }}   
        
void drawLabela3(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1175 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 206 + Table.Y.Offset);
        }} 
        
void drawLabela4(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1175 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 218 + Table.Y.Offset);
        }} 
        
void drawLabela5(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1175 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 230 + Table.Y.Offset);
        }}   
        
void drawLabela6(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1175 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 242 + Table.Y.Offset);
        }}   
        
void drawLabela7(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1175 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 254 + Table.Y.Offset);
        }} 
        
void drawLabela8(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1175 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 266 + Table.Y.Offset);
        }}  
        
void drawLabela9(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1175 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 282 + Table.Y.Offset);
        }}   
        
void drawLabela10(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1175 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 294 + Table.Y.Offset);
        }}                                                                                    

void drawLabel000(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1065 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 170 + Table.Y.Offset);
        }}      
  
void drawLabel001(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1065 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 182 + Table.Y.Offset);
        }}    
        
void drawLabel002(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1065 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 194 + Table.Y.Offset);
        }}    
        
void drawLabel003(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1065 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 206 + Table.Y.Offset);
        }}     
        
void drawLabel004(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1065 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 218 + Table.Y.Offset);
        }} 
        
void drawLabel005(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1065 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 230 + Table.Y.Offset);
        }}  
        
void drawLabel006(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1065 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 242 + Table.Y.Offset);
        }} 
        
void drawLabel007(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1065 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 254 + Table.Y.Offset);
        }} 
        
void drawLabel008(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1065 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 266 + Table.Y.Offset);
        }}      
        
void drawLabel08(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1120 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 154 + Table.Y.Offset);
        }}  
        
void drawLabel09(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1120 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 142 + Table.Y.Offset);
        }}   
        
void drawLabel1001(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1120 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 170 + Table.Y.Offset);
        }}     
        
void drawLabel1002(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1120 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 182 + Table.Y.Offset);
        }} 
        
void drawLabel1003(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1120 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 194 + Table.Y.Offset);
        }}    
        
void drawLabel1004(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1120 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 206 + Table.Y.Offset);
        }}             
        
void drawLabel1005(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1120 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 218 + Table.Y.Offset);
        }}    
        
void drawLabel1006(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1120 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 230 + Table.Y.Offset);
        }}     
        
void drawLabel1007(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1120 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 242 + Table.Y.Offset);
        }}  
        
void drawLabel1008(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1120 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 254 + Table.Y.Offset);
        }}   
        
void drawLabel1009(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1120 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 266 + Table.Y.Offset);
        }} 
        
void drawLabel1009b(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1120 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 282 + Table.Y.Offset);
        }}  
        
void drawLabel1009c(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1120 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 294 + Table.Y.Offset);
        }}           
        
void drawLabel301(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1089 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 370 + Table.Y.Offset);
        }} 
        
void drawLabel311(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1089 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 382 + Table.Y.Offset);
        }}  
  
void drawLabel321(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1089 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 394 + Table.Y.Offset);
        }}   
        
void drawLabel331(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1089 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 406 + Table.Y.Offset);
        }}                      
        
void drawLabel341(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1089 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 418 + Table.Y.Offset);
        }}   
        
void drawLabel351(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1089 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 430 + Table.Y.Offset);
        }} 
        
void drawLabel361(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1089 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 442 + Table.Y.Offset);
        }}   
        
void drawLabel371(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1089 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 454 + Table.Y.Offset);
        }}  
        
void drawLabel381(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1089 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 466 + Table.Y.Offset);
        }}  
        
void drawLabel391(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1083 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 482 + Table.Y.Offset);
        }}  
        
void drawLabel401(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1083 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 494 + Table.Y.Offset);
        }}   
        
void drawLabel411(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1086 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 354 + Table.Y.Offset);
        }}     
        
void drawLabel421(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1086 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 342 + Table.Y.Offset);
        }}                                                                               

void drawLabelz0(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1120 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 342 + Table.Y.Offset);
        }} 
        
void drawLabelz1(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1120 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 354 + Table.Y.Offset);
        }}         
        
void drawLabelz2(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1120 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 370 + Table.Y.Offset);
        }}         
        
void drawLabelz3(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1120 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 382 + Table.Y.Offset);
        }}    
        
void drawLabelz4(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1120 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 394 + Table.Y.Offset);
        }}              
   
void drawLabelz5(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1120 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 406 + Table.Y.Offset);
        }}         
        
void drawLabelz6(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1120 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 418 + Table.Y.Offset);
        }}                 
        
void drawLabelz7(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1120 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 430 + Table.Y.Offset);
        }}                 
        
void drawLabelz8(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1120 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 442 + Table.Y.Offset);
        }}       
        
void drawLabelz9(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1120 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 454 + Table.Y.Offset);
        }}                           
        
void drawLabelz10(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1120 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 466 + Table.Y.Offset);
        }}              
        
void drawLabelz11(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1120 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 482 + Table.Y.Offset);
        }}                           
        
void drawLabelz12(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1120 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 494 + Table.Y.Offset);
        }}       
     
void drawLabel24(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1090 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 508 + Table.Y.Offset);
        }}           
  
void drawLabelsymbol(string id, string text,int fsize, color fcolor,int f,int r,string font,int window = 0)
     { if(ObjectFind(id)==-1)
         {
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 2);
        ObjectSet(id, OBJPROP_XDISTANCE, 1070 + Table.X.Offset);
        ObjectSet(id, OBJPROP_YDISTANCE, 100 + Table.Y.Offset);
        }}                 
        

// --- End